<template>
  <q-dialog
    ref="dialogRef"
    @hide="onDialogHide"
  >
    <q-card class="q-dialog-plugin">
      <q-img
        v-if="lTrain.img"
        :src="require('@/assets/trains/' + lTrain.img).default"
      >
        <div class="absolute-bottom text-subtitle2 text-center">
          {{ lTrain.name }}
        </div>
      </q-img>

      <h6
        v-else
        class="text-center"
      >
        {{ lTrain.name }}
      </h6>

      <q-separator />

      <q-card-section
        horizontal
        class="row justify-evenly"
      >
        <q-card-section class="col-5 column justify-between flex-center">
          <div class="text-h6">
            Rychlost
          </div>

          <q-knob
            v-model="speed"
            :min="-31"
            :max="31"
            show-value
            size="80px"
            :thickness="0.4"
            color="teal"
            track-color="grey-3"
            class="q-ma-md"
            :readonly="detail"
          />

          <q-btn
            v-if="!detail"
            color="primary"
            icon="play_circle_filled"
            @click="speedClick(lTrain)"
          />
        </q-card-section>

        <q-separator vertical />

        <q-card-section class="col-5 column justify-between flex-center">
          <div class="text-h6">
            Světla
          </div>

          <q-btn
            :color="lTrain.light ? 'accent' : 'primary'"
            icon="lightbulb"
            size="xl"
            :disabled="detail"
            @click="lightClick(lTrain)"
          />
        </q-card-section>
      </q-card-section>
    </q-card>
  </q-dialog>
</template>
<script lang="ts">
import { useDialogPluginComponent, useQuasar } from 'quasar'
import { defineComponent, PropType, ref } from 'vue'
import { TrainModel } from 'web_trains_types'

import { adminMapService } from '@/service'

export default defineComponent({
  name: 'TrainDialog',
  props: {
    train: {
      type: Object as PropType<TrainModel>,
      required: true
    },
    detail: {
      type: Boolean,
      required: true
    }
  },
  emits: [
    ...useDialogPluginComponent.emits
  ],
  setup (props): any {
    const { dialogRef, onDialogHide, onDialogOK, onDialogCancel } = useDialogPluginComponent()

    // train in parent is affected! antipattern!
    const lTrain = ref(props.train)

    const speed = ref<number>(0)

    const $q = useQuasar()

    const lightClick = (train: TrainModel) => {
      adminMapService.lights(!train.light, train.tcpName, train.id)
        .then((success) => {
          if (!success) {
            return
          }

          train.light = !train.light

          const message = train.light ? 'rozsvíceno' : 'zhasnuto'

          $q.notify({
            message: train.name + ': světlo ' + message,
            type: 'positive'
          })
        })
    }

    const speedClick = (train: TrainModel) => {
      adminMapService.speed(speed.value, train.tcpName, train.id)
        .then((success) => {
          if (!success) {
            return
          }

          let message = ''

          if (speed.value > 0) {
            message = ' jede rychlostí ' + speed.value
          } else if (speed.value < 0) {
            message = ' couvá rychlostí ' + (-speed.value)
          } else {
            message = ' stojí'
          }

          train.speed = speed.value

          $q.notify({
            message: train.name + message,
            type: 'positive'
          })
        })
    }

    return {
      dialogRef,
      onDialogHide,
      onDialogCancel,
      onDialogOK,
      lightClick,
      speedClick,
      lTrain,
      speed
    }
  }
})

</script>
